{{
  QS_IR_Remote-LCD2.spin        Richard Lamb 
  IR_Remote_NewCog.spin         Tom Doyle (OBEX)
  FullDuplexSerial.spin         Chip Gracey, Jeff Martin, Daniel Harris (OBEX)
}}
CON
  _CLKMODE = XTAL1 + PLL16X     ' 80 Mhz clock
  _XINFREQ = 5_000_000

  IRpin  = 2                    ' IR Remote pin
  TxPin  = 0                    ' LCD serial data pin

' LCD controls
  LCDbs = 8
  LCDclear = 12
  LCDlf = 13
  LCDcursorOff = 16 
  LCDbackOn = 17
  LCDbackOff = 18
  LCDblink = 19
         
OBJ
  IR    : "IR_Remote"
  LCD : "FullDuplexSerial.spin"
    
VAR
  byte IRcode , LED,  X, Power, Channel
  LONG MS001, Twait, Tclear, Tback 
  
PUB Init | freq, index, IRcog, lcode
  Twait := ClkFREQ  /40         ' / 20  '/3 for slo-mo   
  MS001 := CLKFREQ / 1_000      ' define count for 1 millisec

  outa[ 16..23 ] := $00         ' all LED pins off    '
  dira[ 16..23 ] := $FF         ' all LED pins outputs   '

  PowerUp
  Power := 1
  
  LED := 7
  LEDON(LED)
   
' Start LCD display
  LCD.start(TxPin, TxPin, %1000, 9_600)
  WaitCnt(ClkFreq / 100 + Cnt)          ' Pause to initialize
  LCD.tx(LCDclear)
  WaitCnt(ClkFreq / 100 + Cnt)          ' Pause to initialize   
  LCD.tx(LCDcursorOff)
  WaitCnt(ClkFreq / 100 + Cnt)          ' Pause to initialize
  LCD.tx(LCDbackOn)
    
 
   
'Start IR decoder  
  IRcog := ir.Start(IRpin, @IRcode)      ' pin for IR receiver, address of IRcode
  if IRcog > 0

     repeat

        If IRcode <> ir#NoNewCode
          lcode := IRcode
          ir.Start(IRpin, @IRcode)        ' scan for next code

          case lcode
                                'Numbers first  - 1 through 8 only        
            ir#zero  :          'ignore
                        
            ir#one   :
              LED := Lcode
              LCD.tx(LCDclear)                    
              LCD.str(String("One ", LCDlf))    
              LEDon(LED)                         
            
            ir#two   :
              LCD.tx(LCDclear)                   
              LCD.str(String("Two ", LCDlf))    
              LED := Lcode
              LEDon(LED)                           
              
            ir#three :
              LED := Lcode
              LCD.tx(LCDclear)                
              LCD.str(String("Three ", LCDlf))    
              LEDon(LED)           
                                      
            ir#four  :
              LED := Lcode            
              LCD.tx(LCDclear)                 
              LCD.str(String("Four ", LCDlf))    
              LEDon(LED)           
                          
            ir#five  :
              LED := Lcode
              LCD.tx(LCDclear)                      '
              LCD.str(String("Five ", LCDlf))    
              LEDon(LED)           
                  
            ir#six   :
              LED := Lcode            
              LCD.tx(LCDclear)                  
              LCD.str(String("Six ", LCDlf))    
              LEDon(LED)                         
            
            ir#seven :
              LED := Lcode              
              LCD.tx(LCDclear)                        
              LCD.str(String("Seven ", LCDlf))       
                                               
            
            ir#two   :
              LCD.tx(LCDclear)                   
              LCD.str(String("Two ", LCDlf))    
              LED := Lcode
              LEDon(LED)                           

                            
            ir#three :
              LED := Lcode
              LCD.tx(LCDclear)                
              LCD.str(String("Three ", LCDlf))    
              LEDon(LED)           

                                                    
            ir#four  :
              LED := Lcode            
              LCD.tx(LCDclear)                 
              LCD.str(String("Four ", LCDlf))    
              LEDon(LED)           

                                        
            ir#five  :
              LED := Lcode
              LCD.tx(LCDclear)                      '
              LCD.str(String("Five ", LCDlf))    
              LEDon(LED)           

                                
            ir#six   :
              LED := Lcode            
              LCD.tx(LCDclear)                  
              LCD.str(String("Six ", LCDlf))    
              LEDon(LED)
                         
            
            ir#seven :
              LED := Lcode              
              LCD.tx(LCDclear)                        
              LCD.str(String("Seven ", LCDlf))    
              LEDon(LED)

                                         
            ir#eight :
              LED := Lcode             
              LCD.tx(LCDclear)                 
              LCD.str(String("Eight ", LCDlf))
              LEDon(LED)

                            
            ir#nine  :           'ignore 
              
'-----------------------------------------------------
                                'Channel
            ir#chUp  :
              if Channel < 256
                Channel ++
              else
                Channel := 0
                
             LCD.tx(LCDclear)                         
             LCD.str(String("Channel Up ", LCDlf))
             LCD.dec (Channel)    
              
                               
            ir#chDn  :
               if Channel > 0
                 Channel --
               else
                 Channel := 255   
               
               LCD.tx(LCDclear)                          
               LCD.str(String("Channel Down ", LCDlf))
               LCD.dec (Channel)
                   
 
                                'Volume
            ir#volDn :
              if LED < 7
                 LED++
              else
                 LED := 0
              LEDon(LED)

              LCD.tx(LCDclear)                                                        
              LCD.str(String("Volume Down ", LCDlf))
              LCD.dec(LED)

              
            ir#volUp :
              if LED > 0
                 LED--
              else              ' wrap around
                 LED := 7
              LEDon(LED)
                               
              LCD.tx(LCDclear)
              LCD.str(String("Volume Up ", LCDlf))
              LCD.dec (LED)    

              
            ir#ok  :
               LCD.tx(12)                          
               LCD.str(String("OK", LCDlf))    
               outa [16..23] := 0
               outa [16..23] := %11111111
               waitMS(101)
               outa [16..23] := 0                              
               waitMS(180)
              
            ir#power :
               LCD.tx(LCDclear)                           
               if Power == 0
                 LCD.str(String("Power Up", LCDlf))               
                 PowerUp
                 Power := 1

                              
               else
                 LCD.str(String("Power Down", LCDlf))                   
                 PowerDown
                 Power := 0

                                  
               X := LED
               dira[16..23] := %11111111
               outa[16..23] := 0                
              LED := X
              LEDON(LED)

Pub PowerUp

  repeat  Led FROM 23 to 16
     outa[LED..LED+2] := %111
     WaitCnt(Twait+cnt)
     outa[Led+2] := 0
     waitCnt (Twait+cnt)
     outa [LED+1] := 0
     WaitCnt(Twait+cnt)
   
  LED := 0
                    
PUB PowerDown

  repeat  Led FROM 16 to 23
     outa[LED..LED-2] := %111
     WaitCnt(Twait+cnt)
     outa[Led-2]  := 0
     WaitCnt(Twait+cnt)
     outa [LED-1] := 0
     WaitCnt(Twait+cnt)
     
  LED := 7    
             
PRI LEDON(n)
  outa [16..23] := 0
  outa [16+n]:= 1

PRI LEDOFF(n)
   outa [16..32] := 0
   
PUB WaitMS(W)                      'wait for W milliseconds
  W := W * MS001                
  WaitCNT (W+cnt)

DAT      
+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                                                                              
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+  